<template>
  <Dialog v-model="dialogVisible" title="选择物料" style="width: 1100px; max-height: 800px">
    <ContentWrap>
      <el-form
        class="-mb-15px"
        :model="queryParams"
        ref="queryFormRef"
        :inline="true"
        label-width="68px"
      >
        <el-form-item label="物料编码" prop="code">
          <el-input
            v-model="queryParams.code"
            placeholder="请输入物料编码"
            clearable
            @keyup.enter="handleQuery"
          />
        </el-form-item>
        <el-form-item label="物料名称" prop="name">
          <el-input
            v-model="queryParams.name"
            placeholder="请输入物料名称"
            clearable
            @keyup.enter="handleQuery"
          />
        </el-form-item>
        <el-form-item>
          <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
          <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        </el-form-item>
      </el-form>
    </ContentWrap>
    <ContentWrap>
      <el-table
        v-loading="loading"
        :data="list"
        :stripe="true"
        :show-overflow-tooltip="true"
        @row-click="handleRowClick"
      >
        <el-table-column width="60" label="选择">
          <template #default="{ row }">
            <el-radio
              :model-value="selectedRow?.id"
              :label="row.id"
              @click.stop="selectRow(row)"
              class="no-label-radio"
            />
          </template>
        </el-table-column>
        <el-table-column
          label="物料编码"
          align="center"
          prop="code"
          :show-overflow-tooltip="true"
          class="!w-100px"
        />
        <el-table-column
          label="物料名称"
          align="center"
          prop="name"
          :show-overflow-tooltip="true"
        />
        <el-table-column label="单位" align="center" prop="unit"  />
        <el-table-column label="总库存数量" align="center" prop="totalCount"/>
      </el-table>
      <!-- 分页 -->
      <Pagination
        :total="total"
        v-model:page="queryParams.pageNo"
        v-model:limit="queryParams.pageSize"
        @pagination="getList"
      />
    </ContentWrap>
  </Dialog>
</template>

<script setup lang="ts">
import * as MaintainMaterialApi from '@/api/pms/maintain/material'
import { IotMaintainMaterialVO } from '@/api/pms/maintain/material'
import { propTypes } from '@/utils/propTypes'

const emit = defineEmits(['choose']) // 定义 success 事件，用于操作成功后的回调
const dialogVisible = ref(false) // 弹窗的是否展示
const loading = ref(true) // 列表的加载中
const queryFormRef = ref() // 搜索的表单
const list = ref<IotMaintainMaterialVO[]>([]) // 列表的数据
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  deptId: undefined
})
const props = defineProps({
  deptId: propTypes.number.def(undefined)
})
const selectedRow = ref(null)

// 处理单选逻辑
const selectRow = (row) => {
  selectedRow.value = selectedRow.value?.id === row.id ? null : row
  emit('choose', row)
  dialogVisible.value = false
}

// 点击整行选中
const handleRowClick = (row) => {
  selectRow(row)
}
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  await getList()
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗
const getList = async () => {
  loading.value = true
  try {
    queryParams.deptId = props.deptId
    const data =
      await MaintainMaterialApi.IotMaintainMaterialApi.getMaterialsByDeviceId(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}
const choose = (row: IotMaintainMaterialVO) => {
  emit('choose', row)
  dialogVisible.value = false
}
/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}
</script>
<style lang="scss">
.no-label-radio .el-radio__label {
  display: none;
}
.no-label-radio .el-radio__inner {
  margin-right: 0;
}
</style>
